/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package basicbattlesimulator;

import java.util.Random;

/**
 *
 * @author W0229152
 */
abstract class Character {
    protected BodyArmour bodyArmour;
    protected Weapon weapon;
    protected String displayName; //what shows up on the battle screen (this'll just be the "character" name for now)
    protected String charName; //eg: "Egberth" or what have you
    protected String charClass; //eg: "Knight"
    protected int healthPointMax;
    protected int healthPoints; // HPMAX - DMG = HP
    protected int strength;
    protected int attack; // ATK = STR + (weapon)PWR
    protected int endurance;
    protected int defence; // DEF = END + (armour)RESIST
    protected int agility;
    protected int speed; // SPD = AGIL + (equip)AGILMOD
    protected int accuracy;
    protected int hit; // HIT = ACC + (weapon)HITBONUS (Any hit above 255 always strikes - see Attack below)
      
    abstract String battleCry(Character otherCharacter);
    
    public int Attack(Character defendingCharacter){
        int damage = 0;
        int hitThreshold = 0;
        Random randomizer = new Random();
        hitThreshold = randomizer.nextInt(255);
        if (this.hit <= hitThreshold){
            damage = -1;
            return damage;//-1 means a miss
        }
        //hit logic here: hit must exceed threshold to make "contact"
        //there is no evade / dodging in this game, but perhaps there should be :-)
        if ((this.attack - defendingCharacter.defence) > 0) damage = this.attack - defendingCharacter.defence;
        return damage;//damage of -1 means a miss; 0 means attack was too weak to do any damage
    }
    
    protected void assignProperties()
    {
    healthPoints = healthPointMax; // HPMAX - DMG = HP
    attack = strength + weapon.power; // ATK = STR + (weapon)PWR
    defence = endurance + bodyArmour.resistance; // DEF = END + (armour)RESIST
    if ((agility + weapon.agilityModifier + bodyArmour.agilityModifier)>=0)
    {
    speed = agility + weapon.agilityModifier + bodyArmour.agilityModifier; // SPD = AGIL + (equip)AGILMOD , but SPD can't be less than 0
    }
    else speed = 0;
    hit = accuracy + weapon.hitBonus; // HIT = ACC + (weapon)HITBONUS
    //(Any hit above 255 always strikes: if random number (0-255) >= HIT, you miss)
    }
}
