/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package basicbattlesimulator;

import java.lang.Math;

import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.Executors;
import static java.util.concurrent.TimeUnit.*;


/**
 *
 * @author William Matheson
 */
public class FightThread implements Runnable{
       
    protected Character attacker;
    protected Character defender;
    protected int damage;
    protected int delayTime;
    protected int waitTime;
    protected float waitTimeDec;
    protected String results;
    
    FightThread(Character attackerIn, Character defenderIn, int delayTimeIn){
        attacker = attackerIn;
        defender = defenderIn;
        delayTime = delayTimeIn; //ms
        //for testing
        //String appendMe = "I got constructed!\n";
        //BasicBattleSimulatorView.battleReportTextArea.append(appendMe);
    }//end constructor
    
    public void run() {
        //executes once
	BattleController.battleUpdate += attacker.battleCry(defender);
        int waitTimeDec = (1000*(10/(attacker.speed + 1))); //in ms - character with speed zero takes 10s or 10000ms btw turns
        int waitTime = Math.round(waitTimeDec);
		final Runnable attacking = new Runnable() {
                public void run() { 
                    //stuff to execute repeatedly
                        damage = attacker.Attack(defender); //this line needs to execute every time since the attack might miss
                        if (damage == -1)
                        {
                                results = attacker.displayName + "'s attack missed!\n";
                        }
                        if (damage >= 0)
                        {
                                if (damage == 1) results = attacker.displayName + " strikes " + defender.displayName + " for " + damage + " point\n";
                                else results = attacker.displayName + " strikes " + defender.displayName + " for " + damage + " points\n";
                                defender.healthPoints = defender.healthPoints - damage; //this line subtracts the damage from the opponent's HP
                        }
                        BattleController.battleUpdate += results;
                        if (defender.healthPoints <= 0)
                        {
                                BattleController.battleUpdate += defender.displayName + " dies.\n";
                                try{
                                Thread.sleep(100);
                                }catch(Exception e){}//no need to handle it
                                BattleController.battleComplete = true;
                        }
                    }
            };
        final ScheduledFuture<?> fightHandle =
            scheduler.scheduleAtFixedRate(attacking, delayTime, waitTime, MILLISECONDS);
        scheduler.schedule(new Runnable() {
                public void run() { fightHandle.cancel(true); }
            }, 60*60, SECONDS);
    }
    
private final ScheduledExecutorService scheduler =
       Executors.newScheduledThreadPool(1);
    
}//end class